<template>
  <!-- Input wrapper -->
  <label :class="getElementCssClass('wrapper')">

    <!--
      @slot Label slot
    -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="getElementCssClass('label')"
      >
        <div>{{ label }}</div>
        <span v-if="required"> *</span>
      </div>
    </slot>

    <!--
      @slot Input slot
    -->
    <slot name="input">
      <div class="relative">
        <t-input
          :ref="inputRef"
          v-model="vModel"
          :disabled="disabled"
          :name="name"
          :type="passwordVisibility ? 'text' : 'password'"
          :variant="variant"
          :fixed-classes="tInputStyle.fixedClasses"
          :classes="tInputStyle.classes"
          :variants="tInputStyle.variants"
          :required="required"
          :placeholder="placeholder"
          :autocomplete="autocomplete"
        />
        <slot name="inputButton">
          <v-icon
            :name="passwordVisibility
              ? 'eye-slash'
              : 'eye'
            "
            :class="passwordVisibility
              ? getElementCssClass('visibleIcon')
              : getElementCssClass('hiddenIcon')
            "
            @click="passwordVisibility = !passwordVisibility"
          />
        </slot>
      </div>
    </slot>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Description slot
      -->
      <slot
        v-if="description.length > 0"
        name="description"
      >
        <!-- Description -->
        <div :class="getElementCssClass('description')">
          <p>{{ description }}</p>
        </div>
      </slot>
    </transition>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Error slot
      -->
      <slot
        v-if="error.length > 0"
        name="error"
      >
        <!-- Error message -->
        <div :class="getElementCssClass('error')">
          <p>{{ error }}</p>
        </div>
      </slot>
    </transition>

  </label>
</template>

<script>
import BaseInput from '@/components/commons/form/BaseInput.vue'
import Style from './style'

/**
 * **VInputPassword** component
 *
 * See also [vue-tailwind TInput documentation](https://www.vue-tailwind.com/docs/text-input)
 */
export default {
  name: 'VInputPassword',
  extends: BaseInput,
  props: {
    /**
     * value (to use v-model directive)
     *
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      passwordVisibility: false
    }
  },
  computed: {
    /**
     * ⚠ We have to flatten nested object because TInput original component requires
     * a one-level object as props for style
     * @returns {object} An object following VariantableOptions structure
     */
    tInputStyle: function () {
      return {
        fixedClasses: this.style.fixedClasses.input,
        classes: this.style.classes.input,
        variants: Object.keys(this.style.variants).reduce((obj, variant) => {
          obj[variant] = this.style.variants[variant].input
          return obj
        }, {})
      }
    }
  },
  // Variantable option
  style: Style
}
</script>
